Index: soft/giet_vm/boot/boot_init.c
===================================================================
--- soft/giet_vm/boot/boot_init.c	(revision 236)
+++ soft/giet_vm/boot/boot_init.c	(revision 238)
@@ -686,58 +591,56 @@
 
     // global segments
-    for (vseg_id = 0; vseg_id < header->globals; vseg_id++) {
+    for (vseg_id = 0; vseg_id < header->globals; vseg_id++) 
+    {
         vpn = vseg[vseg_id].vbase >> 12;
-        ppn = vseg[vseg_id].pbase >> 12;
+        ppn = (unsigned int)(vseg[vseg_id].pbase >> 12);
         npages = vseg[vseg_id].length >> 12;
-        if ((vseg[vseg_id].length & 0xFFF) != 0) {
-            npages++;
-        }
+        if ((vseg[vseg_id].length & 0xFFF) != 0) npages++;
 
         flags = PTE_V;
-        if (vseg[vseg_id].mode & C_MODE_MASK) {
-            flags = flags | PTE_C;
-        }
-        if (vseg[vseg_id].mode & X_MODE_MASK) {
-            flags = flags | PTE_X;
-        }
-        if (vseg[vseg_id].mode & W_MODE_MASK) {
-            flags = flags | PTE_W;
-        }
-        if (vseg[vseg_id].mode & U_MODE_MASK) {
-            flags = flags | PTE_U;
-        }
+        if (vseg[vseg_id].mode & C_MODE_MASK)  flags = flags | PTE_C;
+        if (vseg[vseg_id].mode & X_MODE_MASK)  flags = flags | PTE_X;
+        if (vseg[vseg_id].mode & W_MODE_MASK)  flags = flags | PTE_W;
+        if (vseg[vseg_id].mode & U_MODE_MASK)  flags = flags | PTE_U;
 
 #if BOOT_DEBUG_PT
         boot_puts(vseg[vseg_id].name);
-        boot_puts(" / flags = ");
+        boot_puts(" : flags = ");
         boot_putx(flags);
         boot_puts(" / npages = ");
         boot_putd(npages);
         boot_puts(" / pbase = ");
-        boot_putx(vseg[vseg_id].pbase);
+        boot_putl(vseg[vseg_id].pbase);
         boot_puts("\n");
 #endif
         // loop on 4K pages
-        for (page_id = 0; page_id < npages; page_id++) {
-            boot_add_pte(vspace_id, vpn, flags, ppn);
+        for (page_id = 0; page_id < npages; page_id++) 
+        {
+            boot_add_pte(vspace_id, vpn, flags, ppn, verbose);
             vpn++;
             ppn++;
         }
     }
-}                // end boot_vspace_pt_build()
+}   // end boot_vspace_pt_build()
 
 
 ///////////////////////////////////////////////////////////////////////////
-// Align the value "toAlign" to the required alignement indicated by
-// alignPow2 ( the logarithme of 2 the alignement).
+// Align the value of paddr or vaddr to the required alignement,
+// defined by alignPow2 == L2(alignement).
 ///////////////////////////////////////////////////////////////////////////
-unsigned int align_to(unsigned int toAlign, unsigned int alignPow2) {
+paddr_t paddr_align_to(paddr_t paddr, unsigned int alignPow2) 
+{
+    paddr_t mask = (1 << alignPow2) - 1;
+    return ((paddr + mask) & ~mask);
+}
+
+unsigned int vaddr_align_to(unsigned int vaddr, unsigned int alignPow2) 
+{
     unsigned int mask = (1 << alignPow2) - 1;
-    return ((toAlign + mask) & ~mask);
-}
-
+    return ((vaddr + mask) & ~mask);
+}
 
 ///////////////////////////////////////////////////////////////////////////
-// This function compute the physical base address for a vseg
+// This function computes the physical base address for a vseg
 // as specified in the mapping info data structure.
 // It updates the pbase and the length fields of the vseg.
@@ -747,24 +650,30 @@
 // It is a global vseg if vspace_id = (-1). 
 ///////////////////////////////////////////////////////////////////////////
-void boot_vseg_map(mapping_vseg_t * vseg, unsigned int vspace_id) {
+void boot_vseg_map(mapping_vseg_t * vseg, unsigned int vspace_id) 
+{
     unsigned int vobj_id;
     unsigned int cur_vaddr;
-    unsigned int cur_paddr;
+    paddr_t      cur_paddr;
+    unsigned int offset;
+
     mapping_header_t * header = (mapping_header_t *) & seg_mapping_base;
-    mapping_vobj_t * vobj = boot_get_vobj_base(header);
+    mapping_vobj_t   * vobj   = boot_get_vobj_base(header);
 
     // get physical segment pointer
-    mapping_pseg_t * pseg = boot_pseg_get(vseg->psegid);
+    mapping_pseg_t* pseg = boot_pseg_get(vseg->psegid);
 
     // compute vseg physical base address
-    if (vseg->ident != 0) {   // identity mapping required
+    if (vseg->ident != 0)                   // identity mapping required
+    {
         vseg->pbase = vseg->vbase;
     }
-    else {  // unconstrained mapping
+    else                                   // unconstrained mapping
+    {
         vseg->pbase = pseg->next_base;
 
         // test alignment constraint
-        if (vobj[vseg->vobj_offset].align) {
-            vseg->pbase = align_to(vseg->pbase, vobj[vseg->vobj_offset].align);
+        if (vobj[vseg->vobj_offset].align) 
+        {
+            vseg->pbase = paddr_align_to(vseg->pbase, vobj[vseg->vobj_offset].align);
         }
     }
@@ -778,8 +687,11 @@
     cur_paddr = vseg->pbase;
 
-    for (vobj_id = vseg->vobj_offset; vobj_id < (vseg->vobj_offset + vseg->vobjs); vobj_id++) {
-        if (vobj[vobj_id].align) {
-            cur_paddr = align_to(cur_paddr, vobj[vobj_id].align);
-            cur_vaddr = align_to(cur_vaddr, vobj[vobj_id].align);
+    for (vobj_id = vseg->vobj_offset; 
+         vobj_id < (vseg->vobj_offset + vseg->vobjs); vobj_id++) 
+    {
+        if (vobj[vobj_id].align) 
+        {
+            cur_paddr = paddr_align_to(cur_paddr, vobj[vobj_id].align);
+            cur_vaddr = vaddr_align_to(cur_vaddr, vobj[vobj_id].align);
         }
         // set vaddr/paddr for current vobj
@@ -787,13 +699,16 @@
         vobj[vobj_id].paddr = cur_paddr;
         
-        // initialise boot_ptabs_vaddr[] if current vobj is a PTAB
-        if (vobj[vobj_id].type == VOBJ_TYPE_PTAB) {
-            if (vspace_id == ((unsigned int) -1)) {   // global vseg
+        // initialise boot_ptabs_vaddr[] & boot_ptabs-paddr[] if PTAB
+        if (vobj[vobj_id].type == VOBJ_TYPE_PTAB) 
+        {
+            if (vspace_id == ((unsigned int) -1))    // global vseg
+            {
                 boot_puts("\n[BOOT ERROR] in boot_vseg_map() function: ");
                 boot_puts("a PTAB vobj cannot be global");
                 boot_exit();
             }
-            // we need at least one PT2 => ( boot_max_pt2[vspace_id] >= 1)
-            if (vobj[vobj_id].length < (PT1_SIZE + PT2_SIZE)) {
+            // we need at least one PT2
+            if (vobj[vobj_id].length < (PT1_SIZE + PT2_SIZE)) 
+            {
                 boot_puts("\n[BOOT ERROR] in boot_vseg_map() function, ");
                 boot_puts("PTAB too small, minumum size is: ");
@@ -802,22 +717,29 @@
             }
             // register both physical and virtual page table address
-            boot_ptabs_vaddr[vspace_id] = (page_table_t *) vobj[vobj_id].vaddr;
-            boot_ptabs_paddr[vspace_id] = (page_table_t *) vobj[vobj_id].paddr;
-
-            /* computing the number of second level page */
+            boot_ptabs_vaddr[vspace_id] = vobj[vobj_id].vaddr;
+            boot_ptabs_paddr[vspace_id] = vobj[vobj_id].paddr;
+
+            // reset all valid bits in PT1
+            for ( offset = 0 ; offset < 8192 ; offset = offset + 4)
+            {
+                boot_physical_write( cur_paddr + offset, 0);
+            }
+
+            // computing the number of second level pages
             boot_max_pt2[vspace_id] = (vobj[vobj_id].length - PT1_SIZE) / PT2_SIZE;
         }
+
         // set next vaddr/paddr
-        cur_vaddr += vobj[vobj_id].length;
-        cur_paddr += vobj[vobj_id].length;
-
+        cur_vaddr = cur_vaddr + vobj[vobj_id].length;
+        cur_paddr = cur_paddr + vobj[vobj_id].length;
     } // end for vobjs
 
     //set the vseg length
-    vseg->length = align_to((cur_paddr - vseg->pbase), 12);
+    vseg->length = vaddr_align_to((unsigned int)(cur_paddr - vseg->pbase), 12);
 
     // checking pseg overflow
     if ((vseg->pbase < pseg->base) ||
-            ((vseg->pbase + vseg->length) > (pseg->base + pseg->length))) {
+        ((vseg->pbase + vseg->length) > (pseg->base + pseg->length))) 
+    {
         boot_puts("\n[BOOT ERROR] in boot_vseg_map() function\n");
         boot_puts("impossible mapping for virtual segment: ");
@@ -825,5 +747,5 @@
         boot_puts("\n");
         boot_puts("vseg pbase = ");
-        boot_putx(vseg->pbase);
+        boot_putl(vseg->pbase);
         boot_puts("\n");
         boot_puts("vseg length = ");
@@ -831,8 +753,8 @@
         boot_puts("\n");
         boot_puts("pseg pbase = ");
-        boot_putx(pseg->base);
+        boot_putl(pseg->base);
         boot_puts("\n");
         boot_puts("pseg length = ");
-        boot_putx(pseg->length);
+        boot_putl(pseg->length);
         boot_puts("\n");
         boot_exit();
@@ -846,14 +768,14 @@
     boot_putx(vseg->vbase);
     boot_puts(" / pbase = ");
-    boot_putx(vseg->pbase);
+    boot_putl(vseg->pbase);
     boot_puts("\n");
 #endif
 
-    // set the next_base field in vseg
-    if (vseg->ident == 0 && pseg->type != PSEG_TYPE_PERI) {
+    // set the next_base field in pseg when it's a RAM
+    if ( pseg->type == PSEG_TYPE_RAM ) 
+    {
         pseg->next_base = vseg->pbase + vseg->length;
     }
-
-}                // end boot_vseg_map()
+}    // end boot_vseg_map()
 
 /////////////////////////////////////////////////////////////////////
@@ -861,5 +783,6 @@
 // structure (soft), and the giet_config file (hard).
 /////////////////////////////////////////////////////////////////////
-void boot_check_mapping() {
+void boot_check_mapping() 
+{
     mapping_header_t * header = (mapping_header_t *) & seg_mapping_base;
     mapping_cluster_t * cluster = boot_get_cluster_base(header);
@@ -867,5 +790,6 @@
 
     // checking mapping availability
-    if (header->signature != IN_MAPPING_SIGNATURE) {
+    if (header->signature != IN_MAPPING_SIGNATURE) 
+    {
         boot_puts("\n[BOOT ERROR] Illegal mapping signature: ");
         boot_putx(header->signature);
@@ -874,5 +798,6 @@
     }
     // checking number of clusters
-    if (header->clusters != NB_CLUSTERS) {
+    if (header->clusters != NB_CLUSTERS) 
+    {
         boot_puts("\n[BOOT ERROR] Incoherent NB_CLUSTERS");
         boot_puts("\n             - In giet_config,  value = ");
@@ -884,5 +809,6 @@
     }
     // checking number of virtual spaces
-    if (header->vspaces > GIET_NB_VSPACE_MAX) {
+    if (header->vspaces > GIET_NB_VSPACE_MAX) 
+    {
         boot_puts("\n[BOOT ERROR] : number of vspaces > GIET_NB_VSPACE_MAX\n");
         boot_puts("\n");
@@ -894,7 +820,9 @@
     unsigned int tty_found = 0;
     unsigned int nic_found = 0;
-    for (cluster_id = 0; cluster_id < NB_CLUSTERS; cluster_id++) {
+    for (cluster_id = 0; cluster_id < NB_CLUSTERS; cluster_id++) 
+    {
         // NB_PROCS_MAX
-        if (cluster[cluster_id].procs > NB_PROCS_MAX) {
+        if (cluster[cluster_id].procs > NB_PROCS_MAX) 
+        {
             boot_puts("\n[BOOT ERROR] too many processors in cluster ");
             boot_putd(cluster_id);
@@ -907,13 +835,17 @@
         for (periph_id = cluster[cluster_id].periph_offset;
                 periph_id < cluster[cluster_id].periph_offset + cluster[cluster_id].periphs;
-                periph_id++) {
-            // NB_TTYS
-            if (periph[periph_id].type == PERIPH_TYPE_TTY) {
-                if (tty_found) {
+                periph_id++) 
+        {
+            // NB_TTY_CHANNELS
+            if (periph[periph_id].type == PERIPH_TYPE_TTY) 
+            {
+                if (tty_found) 
+                {
                     boot_puts("\n[BOOT ERROR] TTY component should not be replicated\n");
                     boot_exit();
                 }
-                if (periph[periph_id].channels > NB_TTYS) {
-                    boot_puts("\n[BOOT ERROR] Wrong NB_TTYS in cluster ");
+                if (periph[periph_id].channels > NB_TTY_CHANNELS) 
+                {
+                    boot_puts("\n[BOOT ERROR] Wrong NB_TTY_CHANNELS in cluster ");
                     boot_putd(cluster_id);
                     boot_puts(" : ttys = ");
@@ -924,12 +856,15 @@
                 tty_found = 1;
             }
-            // NB_NICS
-            if (periph[periph_id].type == PERIPH_TYPE_NIC) {
-                if (nic_found) {
+            // NB_NIC_CHANNELS
+            if (periph[periph_id].type == PERIPH_TYPE_NIC) 
+            {
+                if (nic_found) 
+                {
                     boot_puts("\n[BOOT ERROR] NIC component should not be replicated\n");
                     boot_exit();
                 }
-                if (periph[periph_id].channels != NB_NICS) {
-                    boot_puts("\n[BOOT ERROR] Wrong NB_NICS in cluster ");
+                if (periph[periph_id].channels != NB_NIC_CHANNELS) 
+                {
+                    boot_puts("\n[BOOT ERROR] Wrong NB_NIC_CHANNELS in cluster ");
                     boot_putd(cluster_id);
                     boot_puts(" : nics = ");
@@ -941,6 +876,8 @@
             }
             // NB_TIMERS
-            if (periph[periph_id].type == PERIPH_TYPE_TIM) {
-                if (periph[periph_id].channels > NB_TIMERS_MAX) {
+            if (periph[periph_id].type == PERIPH_TYPE_TIM) 
+            {
+                if (periph[periph_id].channels > NB_TIM_CHANNELS) 
+                {
                     boot_puts("\n[BOOT ERROR] Too much user timers in cluster ");
                     boot_putd(cluster_id);
@@ -952,12 +889,14 @@
             }
             // NB_DMAS
-            if (periph[periph_id].type == PERIPH_TYPE_DMA) {
-                if (periph[periph_id].channels != NB_DMAS_MAX) {
+            if (periph[periph_id].type == PERIPH_TYPE_DMA) 
+            {
+                if (periph[periph_id].channels != NB_DMA_CHANNELS) 
+                {
                     boot_puts("\n[BOOT ERROR] Too much DMA channels in cluster ");
                     boot_putd(cluster_id);
                     boot_puts(" : channels = ");
                     boot_putd(periph[periph_id].channels);
-                    boot_puts(" - NB_DMAS_MAX : ");
-                    boot_putd(NB_DMAS_MAX);
+                    boot_puts(" - NB_DMA_CHANNELS : ");
+                    boot_putd(NB_DMA_CHANNELS);
                     boot_puts("\n");
                     boot_exit();
@@ -968,28 +907,25 @@
 } // end boot_check_mapping()
 
-
 /////////////////////////////////////////////////////////////////////
 // This function initialises the physical pages table allocators 
 // for all psegs (i.e. next_base field of the pseg). 
-// In each cluster containing processors, it reserve space for the
-// schedulers in the first RAM pseg found (4k bytes per processor). 
 /////////////////////////////////////////////////////////////////////
-void boot_psegs_init() {
-    mapping_header_t * header = (mapping_header_t *) &seg_mapping_base;
-
-    mapping_cluster_t * cluster = boot_get_cluster_base(header);
-    mapping_pseg_t * pseg = boot_get_pseg_base(header);
+void boot_psegs_init() 
+{
+    mapping_header_t* header   = (mapping_header_t *) &seg_mapping_base;
+    mapping_cluster_t* cluster = boot_get_cluster_base(header);
+    mapping_pseg_t* pseg       = boot_get_pseg_base(header);
 
     unsigned int cluster_id;
     unsigned int pseg_id;
-    unsigned int found;
 
 #if BOOT_DEBUG_PT
-    boot_puts
-        ("\n[BOOT DEBUG] ****** psegs allocators nitialisation ******\n");
-#endif
-
-    for (cluster_id = 0; cluster_id < header->clusters; cluster_id++) {
-        if (cluster[cluster_id].procs > NB_PROCS_MAX) {
+boot_puts ("\n[BOOT DEBUG] ****** psegs allocators initialisation ******\n");
+#endif
+
+    for (cluster_id = 0; cluster_id < header->clusters; cluster_id++) 
+    {
+        if (cluster[cluster_id].procs > NB_PROCS_MAX) 
+        {
             boot_puts("\n[BOOT ERROR] The number of processors in cluster ");
             boot_putd(cluster_id);
@@ -998,42 +934,37 @@
         }
 
-        found = 0;
-
         for (pseg_id = cluster[cluster_id].pseg_offset;
                 pseg_id < cluster[cluster_id].pseg_offset + cluster[cluster_id].psegs;
-                pseg_id++) {
-            unsigned int free = pseg[pseg_id].base;
-
-            if ((pseg[pseg_id].type == PSEG_TYPE_RAM) && (found == 0)) {
-                free = free + (cluster[cluster_id].procs << 12);
-                found = 1;
-            }
-            pseg[pseg_id].next_base = free;
+                pseg_id++) 
+        {
+            pseg[pseg_id].next_base = pseg[pseg_id].base;
 
 #if BOOT_DEBUG_PT
-            boot_puts("cluster ");
-            boot_putd(cluster_id);
-            boot_puts(" / pseg ");
-            boot_puts(pseg[pseg_id].name);
-            boot_puts(" : next_base = ");
-            boot_putx(pseg[pseg_id].next_base);
-            boot_puts("\n");
+boot_puts("cluster ");
+boot_putd(cluster_id);
+boot_puts(" / pseg ");
+boot_puts(pseg[pseg_id].name);
+boot_puts(" : next_base = ");
+boot_putl(pseg[pseg_id].next_base);
+boot_puts("\n");
 #endif
         }
     }
 } // end boot_psegs_init()
-
 
 /////////////////////////////////////////////////////////////////////
 // This function builds the page tables for all virtual spaces 
-// defined in the mapping_info data structure.
-// For each virtual space, it maps both the global vsegs 
-// (replicated in all vspaces), and the private vsegs.
+// defined in the mapping_info data structure, in three steps:
+// - step 1 : It computes the physical base address for global vsegs
+//            and for all associated vobjs.
+// - step 2 : It computes the physical base address for all private 
+//            vsegs and all vobjs in each virtual space.
+// - step 3 : It actually fill the page table for each vspace.
 /////////////////////////////////////////////////////////////////////
-void boot_pt_init() {
+void boot_pt_init() 
+{
     mapping_header_t * header = (mapping_header_t *) &seg_mapping_base;
-
     mapping_vspace_t * vspace = boot_get_vspace_base(header);
-    mapping_vseg_t * vseg = boot_get_vseg_base(header);
+    mapping_vseg_t   * vseg   = boot_get_vseg_base(header);
 
     unsigned int vspace_id;
@@ -1041,24 +972,27 @@
 
 #if BOOT_DEBUG_PT
-    boot_puts("\n[BOOT DEBUG] ****** mapping global vsegs ******\n");
-#endif
-
-    // step 1 : first loop on virtual spaces to map global vsegs
-    for (vseg_id = 0; vseg_id < header->globals; vseg_id++) {
+boot_puts("\n[BOOT DEBUG] ****** mapping global vsegs ******\n");
+#endif
+
+    // step 1 : loop on virtual spaces to map global vsegs
+    for (vseg_id = 0; vseg_id < header->globals; vseg_id++) 
+    {
         boot_vseg_map(&vseg[vseg_id], ((unsigned int) (-1)));
     }
 
     // step 2 : loop on virtual vspaces to map private vsegs
-    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) {
+    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) 
+    {
 
 #if BOOT_DEBUG_PT
-        boot_puts("\n[BOOT DEBUG] ****** mapping private vsegs in vspace ");
-        boot_puts(vspace[vspace_id].name);
-        boot_puts(" ******\n");
+boot_puts("\n[BOOT DEBUG] ****** mapping private vsegs in vspace ");
+boot_puts(vspace[vspace_id].name);
+boot_puts(" ******\n");
 #endif
 
         for (vseg_id = vspace[vspace_id].vseg_offset;
                 vseg_id < (vspace[vspace_id].vseg_offset + vspace[vspace_id].vsegs);
-                vseg_id++) {
+                vseg_id++) 
+        {
             boot_vseg_map(&vseg[vseg_id], vspace_id);
         }
@@ -1066,24 +1000,22 @@
 
     // step 3 : loop on the vspaces to build the page tables
-    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) {
-
+    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) 
+    {
 #if BOOT_DEBUG_PT
-        boot_puts("\n[BOOT DEBUG] ****** building page table for vspace ");
-        boot_puts(vspace[vspace_id].name);
-        boot_puts(" ******\n");
-#endif
-
+boot_puts("\n[BOOT DEBUG] ****** building page table for vspace ");
+boot_puts(vspace[vspace_id].name);
+boot_puts(" ******\n");
+#endif
         boot_vspace_pt_build(vspace_id);
 
 #if BOOT_DEBUG_PT
-        boot_puts("\n>>> page table physical address = ");
-        boot_putx((unsigned int) boot_ptabs_paddr[vspace_id]);
-        boot_puts(", page table number of PT2 = ");
-        boot_putd((unsigned int) boot_max_pt2[vspace_id]);
-        boot_puts("\n");
+boot_puts("\n>>> page table physical address = ");
+boot_putl(boot_ptabs_paddr[vspace_id]);
+boot_puts(", number of PT2 = ");
+boot_putd((unsigned int) boot_max_pt2[vspace_id]);
+boot_puts("\n");
 #endif
     }
 } // end boot_pt_init()
-
 
 ///////////////////////////////////////////////////////////////////////////////
@@ -1091,20 +1023,23 @@
 // such as mwmr channels, barriers and locks, because these vobjs 
 // are not known, and not initialized by the compiler.
+// Warning : The MMU is supposed to be activated...
 ///////////////////////////////////////////////////////////////////////////////
-void boot_vobjs_init() {
-    mapping_header_t * header = (mapping_header_t *) & seg_mapping_base;
-    mapping_vspace_t * vspace = boot_get_vspace_base(header);
-    mapping_vobj_t * vobj = boot_get_vobj_base(header);
+void boot_vobjs_init() 
+{
+    mapping_header_t* header = (mapping_header_t *) & seg_mapping_base;
+    mapping_vspace_t* vspace = boot_get_vspace_base(header);
+    mapping_vobj_t* vobj     = boot_get_vobj_base(header);
 
     unsigned int vspace_id;
     unsigned int vobj_id;
 
-    // loop on the vspaces 
-    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) {
+    // loop on the vspaces
+    for (vspace_id = 0; vspace_id < header->vspaces; vspace_id++) 
+    {
 
 #if BOOT_DEBUG_VOBJS
-        boot_puts("\n[BOOT DEBUG] ****** vobjs initialisation in vspace ");
-        boot_puts(vspace[vspace_id].name);
-        boot_puts(" ******\n");
+boot_puts("\n[BOOT DEBUG] ****** vobjs initialisation in vspace ");
+boot_puts(vspace[vspace_id].name);
+boot_puts(" ******\n");
 #endif
 
@@ -1113,10 +1048,12 @@
         // loop on the vobjs
         for (vobj_id = vspace[vspace_id].vobj_offset;
-                vobj_id < (vspace[vspace_id].vobj_offset + vspace[vspace_id].vobjs);
-                vobj_id++) {
-            switch (vobj[vobj_id].type) {
+             vobj_id < (vspace[vspace_id].vobj_offset + vspace[vspace_id].vobjs);
+             vobj_id++) 
+        {
+            switch (vobj[vobj_id].type) 
+            {
                 case VOBJ_TYPE_MWMR:    // storage capacity is (vobj.length/4 - 5) words
                 {
-                    mwmr_channel_t * mwmr = (mwmr_channel_t *) (vobj[vobj_id].paddr);
+                    mwmr_channel_t* mwmr = (mwmr_channel_t *) (vobj[vobj_id].vaddr);
                     mwmr->ptw = 0;
                     mwmr->ptr = 0;
@@ -1126,11 +1063,11 @@
                     mwmr->lock = 0;
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("MWMR    : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts(" / depth = ");
-                    boot_putd(mwmr->depth);
-                    boot_puts(" / width = ");
-                    boot_putd(mwmr->width);
-                    boot_puts("\n");
+boot_puts("MWMR    : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" / depth = ");
+boot_putd(mwmr->depth);
+boot_puts(" / width = ");
+boot_putd(mwmr->width);
+boot_puts("\n");
 #endif
                     break;
@@ -1139,9 +1076,9 @@
                 {
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("ELF     : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts(" / length = ");
-                    boot_putx(vobj[vobj_id].length);
-                    boot_puts("\n");
+boot_puts("ELF     : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" / length = ");
+boot_putx(vobj[vobj_id].length);
+boot_puts("\n");
 #endif
                     break;
@@ -1150,9 +1087,9 @@
                 {
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("BLOB     : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts(" / length = ");
-                    boot_putx(vobj[vobj_id].length);
-                    boot_puts("\n");
+boot_puts("BLOB     : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" / length = ");
+boot_putx(vobj[vobj_id].length);
+boot_puts("\n");
 #endif
                     break;
@@ -1160,24 +1097,24 @@
                 case VOBJ_TYPE_BARRIER:    // init is the number of participants
                 {
-                    giet_barrier_t * barrier = (giet_barrier_t *) (vobj[vobj_id].paddr);
+                    giet_barrier_t* barrier = (giet_barrier_t *) (vobj[vobj_id].vaddr);
                     barrier->count = vobj[vobj_id].init;
                     barrier->init = vobj[vobj_id].init;
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("BARRIER : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts(" / init_value = ");
-                    boot_putd(barrier->init);
-                    boot_puts("\n");
+boot_puts("BARRIER : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" / init_value = ");
+boot_putd(barrier->init);
+boot_puts("\n");
 #endif
                     break;
                 }
-                case VOBJ_TYPE_LOCK:    // init is "not taken"
-                {
-                    unsigned int * lock = (unsigned int *) (vobj[vobj_id].paddr);
+                case VOBJ_TYPE_LOCK:    // init value is "not taken"
+                {
+                    unsigned int* lock = (unsigned int *) (vobj[vobj_id].vaddr);
                     *lock = 0;
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("LOCK    : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts("\n");
+boot_puts("LOCK    : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts("\n");
 #endif
                     break;
@@ -1186,11 +1123,11 @@
                 {
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("BUFFER  : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts(" / paddr = ");
-                    boot_putx(vobj[vobj_id].paddr);
-                    boot_puts(" / length = ");
-                    boot_putx(vobj[vobj_id].length);
-                    boot_puts("\n");
+boot_puts("BUFFER  : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" / paddr = ");
+boot_putx(vobj[vobj_id].paddr);
+boot_puts(" / length = ");
+boot_putx(vobj[vobj_id].length);
+boot_puts("\n");
 #endif
                     break;
@@ -1198,21 +1135,19 @@
                 case VOBJ_TYPE_MEMSPACE:
                 {
-                    giet_memspace_t * memspace = (giet_memspace_t *) vobj[vobj_id].paddr;
+                    giet_memspace_t* memspace = (giet_memspace_t *) vobj[vobj_id].vaddr;
                     memspace->buffer = (void *) vobj[vobj_id].vaddr + 8;
                     memspace->size = vobj[vobj_id].length - 8;
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("MEMSPACE  : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts(" / paddr = ");
-                    boot_putx(vobj[vobj_id].paddr);
-                    boot_puts(" / vaddr = ");
-                    boot_putx(vobj[vobj_id].vaddr);
-                    boot_puts(" / length = ");
-                    boot_putx(vobj[vobj_id].length);
-                    boot_puts(" / buffer = ");
-                    boot_putx(memspace->buffer);
-                    boot_puts(" / size = ");
-                    boot_putx(memspace->size);
-                    boot_puts("\n");
+boot_puts("MEMSPACE  : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" / vaddr = ");
+boot_putx(vobj[vobj_id].vaddr);
+boot_puts(" / length = ");
+boot_putx(vobj[vobj_id].length);
+boot_puts(" / buffer = ");
+boot_putx((unsigned int)memspace->buffer);
+boot_puts(" / size = ");
+boot_putx(memspace->size);
+boot_puts("\n");
 #endif
                     break;
@@ -1222,9 +1157,9 @@
                     ptab_found = 1;
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("PTAB    : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts(" / length = ");
-                    boot_putx(vobj[vobj_id].length);
-                    boot_puts("\n");
+boot_puts("PTAB    : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" / length = ");
+boot_putx(vobj[vobj_id].length);
+boot_puts("\n");
 #endif
                     break;
@@ -1232,14 +1167,14 @@
                 case VOBJ_TYPE_CONST:
                 {
-                    unsigned int *addr = (unsigned int *) vobj[vobj_id].paddr;
+                    unsigned int* addr = (unsigned int *) vobj[vobj_id].vaddr;
                     *addr = vobj[vobj_id].init;
 #if BOOT_DEBUG_VOBJS
-                    boot_puts("CONST   : ");
-                    boot_puts(vobj[vobj_id].name);
-                    boot_puts(" / Paddr :");
-                    boot_putx(vobj[vobj_id].paddr);
-                    boot_puts(" / init = ");
-                    boot_putx(*addr);
-                    boot_puts("\n");
+boot_puts("CONST   : ");
+boot_puts(vobj[vobj_id].name);
+boot_puts(" / Paddr :");
+boot_putx(vobj[vobj_id].paddr);
+boot_puts(" / init = ");
+boot_putx(*addr);
+boot_puts("\n");
 #endif
                     break;
@@ -1247,5 +1182,5 @@
                 default:
                 {
-                    boot_puts("\n[INIT ERROR] illegal vobj type: ");
+                    boot_puts("\n[BOOT ERROR] illegal vobj type: ");
                     boot_putd(vobj[vobj_id].type);
                     boot_puts("\n");
@@ -1254,6 +1189,7 @@
             }            // end switch type
         }            // end loop on vobjs
-        if (ptab_found == 0) {
-            boot_puts("\n[INIT ERROR] Missing PTAB for vspace ");
+        if (ptab_found == 0) 
+        {
+            boot_puts("\n[BOOT ERROR] Missing PTAB for vspace ");
             boot_putd(vspace_id);
             boot_exit();
